function massder = derivev1(t,M)                                          %Commets for transformation to steady state
global p str  %outlet

%Ensuring that volume feasible relative to mass
Mtot1 = M(10)*10000;
Mtot2 = M(30)*5000;
%Ensuring all weight fractions are feasible
x1 = fraccontr(M(1:6));
%v1 = fraccontr(M(11:13));
%l1 = fraccontr(M(15:20));
x2 = fraccontr(M(22:27));
%v2 = fraccontr(M(31:33));
%l2 = fraccontr(M(35:40));
V1 = Mtot1/p.rho;
V2 = Mtot2/p.rho;
mass1 = x1.*Mtot1;
mass2 = x2.*Mtot2;
T1 = M(8)*(155+273);
T2 = M(29)*(155+273);
P2 = M(44)*100;
Q1 = M(42)*10e6;
Q2 = M(43)*10e6;
C = mass1./p.MW(1:6)./V1;        %Concentration of components [kmol/m^3]
C2 = mass2./p.MW(1:6)./V2;        %Concentration of components [kmol/m^3]
%M(10) = sum(mass1) + M(9);                                     %Total mass
%M(22) = sum(mass2);
%Min2 = M(15:20);
%Partial pressure, pure of A and B
%1st stage
Pp(1) = (10^(8.024 - (1921.6/(T1 - 273.15 + 203.3))))/760*1.0135*100;
Pp(2) = (10^(7.966 - (1668.21/(T1 - 273.15 + 228))))/760*1.0135*100;
%2nd stage
Pp(3) = (10^(8.024 - (1921.6/(T2 - 273.15 + 203.3))))/760*1.0135*100;
Pp(4) = (10^(7.966 - (1668.21/(T2 - 273.15 + 228))))/760*1.0135*100;

%wt. fraction in liquid
x = x1(1:2);                     %1st stage                       
x(3:4) = x2(1:2);              %2nd stage
PS = x.*Pp';               %Equillibrium/saturated pressures (Raoult's law)
%Pressure ration
ryayb = (Pp(1)*x(1))/(Pp(2)*x(2));    %1st stage
ryayb2 = (Pp(3)*x(3))/(Pp(4)*x(4));   %2nd stage
%Pressure, B
P(2,1) = p.Ptot*(1/(1+ryayb));        %1st stage
P(4) = P2*(1/(1+ryayb2));          %2nd stage
%Pressure, A
P(1) = p.Ptot -P(2);                  %1st stage
P(3) = P2 -P(4);                   %2nd stage
%Reaction rate: C + D = A + B + E [kmol/m^3,hr]
R = p.k*C(3)*C(4);                    %1st stage
R(2) = p.k*C2(3)*C2(4);               %2nd stage
%Heating, inlet flow [kJ/hr]
Q = str.Minn./p.MW.*p.CP*(T1-p.Tin);                %Heating, inlet
Qtot = sum(Q);                                                      %--||--
beta = [1 1]';                                    %suggestion [kmol/kPa,hr]
alpha = p.MW(1:2).*beta;
n = [alpha; alpha].*(PS - P);                                        %kg/h Gas outlet - amine and water
%ensuring positive flow of vapour

if min(n) < 0
    if n(1) < 0
        n(1) = 0;
    end
    if n(2) <0
        n(2) = 0;
    end
    if n(3) <0
        n(3) = 0;
    end
    if n(4) <0
        n(4) = 0;
    end
end
MtotVap1 = sum([n(1:2); str.Minn(7)]);
MtotVap2 = sum(n(3:4));
Hvap = [p.Hvap; p.Hvap].*(n./[p.MW(1:2); p.MW(1:2)]);                   %Heat to evaporate [kJ/hr] 
Qrx = p.Hrx*R(1)*V1;                               %Heat of reaction [kJ/hr]
Qrx2 = p.Hrx*R(2)*V2;
dM = V1*p.MW*R(1);                         %Convertion by reaction [kmol/hr]
dM2 = V2*p.MW*R(2);

%calculating liquid outlet nessecary to maintain mass concervation
Mtotout1 = sum(str.Minn) - sum(MtotVap1);
Minn2 = Mtotout1.*x1;       %calcuating mass of components leaving 1st
                                                       %stage, entering 2nd
%Calculating change in components, 1st stage
Mder = str.Minn(1:2) - n(1:2) + [dM(1); 0] - Minn2(1:2);    %Accumulation = inn - out + produced
Mder(3:4) = str.Minn(3:4) -dM(3:4) -Minn2(3:4);
Mder(5) = str.Minn(5) + dM(5) -Minn2(5);
Mder(6) = str.Minn(6) -Minn2(6);
Mder(9) = 0;
Mder(10) = sum(Mder);                                   %Total mass balance
Mder(7) = Mder(10)*V1/Mtot1;                            %Change in volume 
Qb = Q1 - p.Qloss - Qtot - sum(Hvap(1:2)) + Qrx +p.Ptot*Mder(7);%Energy balance
QT = mass1(1:6)./p.MW(1:6).*p.CP(1:6);             %Energy balance, components
Mder(8) = Qb./sum(QT);                                %Change in temperature
%Mder(14) = 0;
%second stage
%calculating liquid outlet nessecary to maintain mass concervation
Qtot2 = sum(Minn2./p.MW(1:6).*p.CP(1:6)*(T2-T1));                       %2nd stage  
waste = sum(Minn2) - MtotVap2;
Mout2 = waste.*x2;       %calcuating mass of components leaving 1st
                                                       %stage, entering 2nd
%Calculating change in components, 1st stage
Mder(22:23) = Minn2(1:2) - n(3:4) + [dM2(1);0] -Mout2(1:2);    %Accumulation = inn - out + produced
Mder(24:25) = Minn2(3:4) - dM2(3:4) -Mout2(3:4);
Mder(26) = Minn2(5) + dM2(5) -Mout2(5);
Mder(27) = Minn2(6) - Mout2(6);

Mder(30) = sum(Mder(22:27));                                   %Total mass balance
Mder(28) = Mder(30)*V2/Mtot2;                            %Change in volume 
Qb2 = Q2 - Qtot2 - sum(Hvap(3:4)) + Qrx2 +P2*Mder(28);%Energy balance
%remember: removed Qloss from latter line
QT2 = mass2./p.MW(1:6).*p.CP(1:6);              %Energy balance, components
Mder(29) = Qb2/sum(QT2);                                %Change in temperature

%---------------------------Scaled diff---------------------------
%comp. in reclaimers
Mdersc = zeros(45,1);
Mdersc(1:6) = (x1*Mtot1 + Mder(1:6))/(Mtot1 + Mder(10)) - M(1:6);
Mdersc(22:27) = (x2*Mtot2 + Mder(22:27))/(Mtot2 + Mder(30)) - M(22:27);
Mdersc(9) = - M(9);
%vaporation
if MtotVap1 <= 0
    Mdersc(11:13) = 0;
else
    Mdersc(11:13)= [n(1:2); str.Minn(7)]./MtotVap1 - M(11:13);
end
if MtotVap2 <= 0
    Mdersc(31:33) = 0;
else
    Mdersc(31:33) = [n(3:4); 0]/MtotVap2 - M(31:33);
end
Mdersc(14) = MtotVap1/1000 - M(14);
Mdersc(34) = MtotVap2/650 - M(34);
%liquid outlet
Mdersc(15:20) = Minn2./sum(Minn2)- M(15:20);
Mdersc(35:40) = Mout2./sum(Mout2) - M(35:40);
Mdersc(21) = sum(Minn2)/1500 - M(21);
Mdersc(41) = sum(Mout2)/1000 - M(41);
%Temperatures
Mdersc(8) = Mder(8)/(155+273);
Mdersc(29) = Mder(29)/(155+273);
%Volumes: Only correcting for deviation between calculated and 
%Mdersc(7) = V1/10 - M(7);
%Mdersc(28) = V2/5 - M(28);
%Total mass in reclaimers
Mdersc(10) = Mder(10)/10000;
Mdersc(30) = Mder(30)/5000;
%Energy lost in waste i.e. not led back into main process simple
%calculation.
Mdersc(45) = (Mout2./p.MW(1:6))'*p.CP(1:6).*(T2-p.Tin).*10e-7 - M(45);

%massder = [Mdersc(1:10) Mdersc(22:30) Mdersc(36) Mdersc(41:45)];
massder = Mdersc;%[Mdersc(1:10); zeros(10,1); Mdersc(21); Mdersc(22:30); zeros(5,1); Mdersc(36); zeros(4,1); Mdersc(41:45)];
end