%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                  %
%           Main script for steady state optimization of           %
%                       amine absorption model                     %
%               Master thesis if Sigrun Dyvik Berstad              %
%          Institute of chemical process technology, NTNU          %
%                       Trondheim, spring 2013                     %
%                                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
clc
clear functions
constant
%close all
global ssM x0
q_init = [0.3 0.1 0.7 0 5000];
x0 = odsmain(q_init,1);
lb = zeros(1,length(x0));
ub = ones(1,length(x0)).*1.1;
ssM = [x0(10) x0(30)];
%ub(8) = 30/31;
ub(21) = 2500/1500;
ub(41) = 2500/1000;
options = optimset('TolFun',0.001,'TolCon',10e-5,'Display','on',...
'UseParallel','always','Algorithm','sqp','Diagnostics',...
'on','MaxFunEval',200000,'TolX',10e-15,'MaxIter',10000);
%[Aeq,beq] = lincon(x0);
[x,fval,exitflag,hessian]=fmincon(@(x)objfunc(x),x0,[],[],[],[],lb,ub,@(x)nonlCon(x),options);
fval
exitflag
M = odsmain([x(42:44) 0 50],2);
[M(1:45); x; x0]