function x0 = odsmain(q,r)
global p
M0 = zeros(1,45);
%initial concentrations and conditions
M0(10) = 500/10000;  %Initial: 500 kg mix in first stage. Deviding with 
                     %10000 so that all x-es are in the same scale.
M0(1:2) = 0.5;         %Weight fraction, MEA and water
M0(7) = M0(10)*10000/p.rho/10; %Volume - calculate from mass and density.
                     %Devide by 10 to get into scale, max = 1.
M0(8) = 393/(155+273); %Initial temperature, scaled so max = 1
M0(11:12) = 0.5;     %Initial wt fraction, vapour stage 1
M0(14) = 0;          %Initial vapour flow from stage 1
M0(15:16) = 0.5;     %Wt frac, liquid stage 1
M0(21) = 0;          %Initial liquid flow, stage 1
M0(30) = 500/5000;  %Initial: 200 kg mix in second stage. Derived with 5000.
M0(22:23) = 0.5;    %Weight fraction MEA and water, stage 2
M0(28) = M0(30)*5000/p.rho/5; %Volume stage 2 - scaled to max = 1
M0(29) = 393/(155+273); %Initial temperature stage 2, scaled to max = 1
M0(31:32) = 0.5;        %Wt frac, vapour stage 2
M0(34) = 0;             %Initial vapour flow from stage 2
M0(35:36) = 0.5;        %Wt frac, liquid stage 2
M0(41) = 0;             %Initial liquid flow, stage 2
M0(42) = q(1);   %Energy consumption, 10^6 kJ stage 1
M0(43) = q(2);   %Energy consumption, 10^6 kJ stage 2
M0(44) = q(3);   %Pressure, stage 2. 10^2kPa
t = [q(4) q(5)];

options = odeset('RelTol',1e-4,'AbsTol',1e-4);
if r == 1
    [t,X] = ode15s(@deriveods,t,M0,options);
    %X(:,46) = X(:,42).*10^6;
    %X(:,47) = X(:,43).*10^6;
    n=1;
    n = plotting2(t,X,n);
elseif r == 2
    M0(46) = 0;
    M0(47) = 0;
   [t,X] = ode15s(@deriveods2,t,M0,options);
else
    disp('invalid choise input')
end
x0 = X(end,:);
%disp(X(:,7))
%disp(X(:,45))
if r == 2
    n = 1;
    n = plotting(t,X,n);
else
end
end