function n = plotting(t,X,n)
figure(n)
subplot(2,1,1)
x11 = X(:,1:2).*[X(:,10).*10000 X(:,10).*10000];
plot(t,x11)
title('Mass, first stage')
xlabel('Time, [hr]')
ylabel('Mass, [kg]')
legend('MEA','H_2O')
subplot(2,1,2)
x11 = X(:,22:23).*[X(:,30).*5000 X(:,30).*5000];
plot(t,x11)
title('Mass, second stage')
xlabel('Time, [hr]')
ylabel('Mass, [kg]')
legend('MEA','H_2O')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,3:6).*[X(:,10).*10000 X(:,10).*10000 X(:,10).*10000 X(:,10).*10000];
plot(t,x11)
title('Mass, first stage')
ylabel('Mass, [kg]')
xlabel('Time, [hr]')
legend('HEF','NaOH','HSS','HEPO')
subplot(2,1,2)
x11 =(X(:,24:27).*[X(:,30).*5000 X(:,30).*5000 X(:,30).*5000 X(:,30).*5000]);
plot(t,x11)
title('Mass, second stage')
ylabel('Mass, [kg]')
xlabel('Time, [hr]')
legend('HEF','NaOH','HSS','HEPO')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,7).*10))
title('Volume, first stage')
ylabel('Volume, [m^3]')
xlabel('Time, [hr]')
%legend('Volume')
subplot(2,1,2)
plot(t,(X(:,28).*5))
title('Volume, second stage')
ylabel('Volume, [m^3]')
xlabel('Time, [hr]')
%legend('Volume')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,8).*(150+273)),'b:')
title('Temperature, first stage')
xlabel('Time, [hr]')
ylabel('Temperature, [K]')
%legend('Temperature')
subplot(2,1,2)
plot(t,(X(:,29).*(150+273)),'b:')
title('Temperature, second stage')
xlabel('Time, [hr]')
ylabel('Temperature, [K]')
%legend('Temperature')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,10).*10000),'r--')
title('Total mass, first stage')
xlabel('Time, [hr]')
ylabel('Mass, [kg]')
%legend('Total mass')
subplot(2,1,2)
plot(t,(X(:,30).*5000),'r--')
title('Total mass, second stage')
xlabel('Time, [hr]')
ylabel('Mass, [kg]')
%legend('Total mass')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,1:6)))
title('Weight fractions, first stage')
xlabel('Time, [hr]')
ylabel('Weight fraction')
legend('MEA','H_20','HEF','NaOH','HSS','HEPO')
subplot(2,1,2)
plot(t,(X(:,22:27)))
title('Weight fractions, second stage')
xlabel('Time, [hr]')
ylabel('Weight fraction')
legend('MEA','H_20','HEF','NaOH','HSS','HEPO')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,11:13).*[X(:,14).*1000 X(:,14).*1000 X(:,14).*1000];
plot(t,x11)
title('Vapour flow, first stage')
xlabel('Time, [hr]')
ylabel('Vapour flow [kg/hr]')
legend('MEA','H_2O','CO_2')
subplot(2,1,2)
xvap2 = X(:,31:33).*[X(:,34).*650 X(:,34).*650 X(:,34).*650];
plot(t,xvap2)
%hold on
%plot(t,(X(:,32).*X(34).*650))
%hold off
xlabel('Time, [hr]')
ylabel('Vapour flow [kg/hr]')
legend('MEA','H_2O','CO_2')
title('Vapour flow, second flow')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,15:20).*[X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500];
plot(t, x11)
legend('MEA','H_20','HEF','NaOH','HSS','HEPO')
xlabel('Time, [hr]')
ylabel('Components in outlet stream [kg/hr]')
title('Liquid flow, first stage ')
subplot(2,1,2)
x11 = X(:,35:40).*[X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000];
plot(t, x11)
legend('MEA','H_20','HEF','NaOH','HSS','HEPO')
xlabel('Time, [hr]')
ylabel('Components in outlet stream [kg/hr]')
title('Liquid flow, second stage ')
n = n+1;
figure(n)
x11 = [X(:,46).*10e6 X(:,47).*10e6 X(:,45).*10e6];
plot(t,x11)
legend('Q_1','Q_2','Q_l_o_s_t')
xlabel('Time, [hr]')
ylabel('Heat, [kJ/h]')
title('Energy consumption in the different stages, and energy lost with waste')