function n = plotting(t,X,n)
figure(n)
subplot(2,1,1)
x11 = X(:,1:2).*[X(:,10).*10000 X(:,10).*10000];
plot(t,x11)
title('Mass, first stage')
xlabel('Time, hr')
ylabel('Mass, kg')
legend('MEA','H2O')
subplot(2,1,2)
x11 = X(:,22:23).*[X(:,30).*5000 X(:,30).*5000];
plot(t,x11)
title('Mass, second stage')
xlabel('Time, hr')
ylabel('Mass, kg')
legend('MEA','H2O')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,3:6).*[X(:,10).*10000 X(:,10).*10000 X(:,10).*10000 X(:,10).*10000];
plot(t,x11)
title('Mass, first stage')
ylabel('Mass, kg')
xlabel('Time, hr')
legend('HEF','NaOH','Sodium formate','HEIA')
subplot(2,1,2)
plot(t,(X(:,24:27).*X(30).*5000))
title('Mass, second stage')
ylabel('Mass, kg')
xlabel('Time, hr')
legend('HEF','NaOH','Sodium formate','HEIA')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,7).*10),'g:')
title('Volume, first stage')
ylabel('Volume, m^3')
xlabel('Time, hr')
legend('Volume')
subplot(2,1,2)
plot(t,(X(:,28).*5),'g:')
title('Volume, second stage')
ylabel('Volume, m^3')
xlabel('Time, hr')
legend('Volume')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,8).*(150+273)),'g:')
title('Temperature, first stage')
xlabel('Time, hr')
ylabel('Temperature, K')
legend('Temperature')
subplot(2,1,2)
plot(t,(X(:,29).*(150+273)),'g:')
title('Temperature, second stage')
xlabel('Time, hr')
ylabel('Temperature, K')
legend('Temperature')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,10).*10000),'r--')
title('Total mass, first stage')
xlabel('Time, hr')
ylabel('Mass, kg')
legend('Total mass')
subplot(2,1,2)
plot(t,(X(:,30).*5000),'r--')
title('Total mass, second stage')
xlabel('Time, hr')
ylabel('Mass, kg')
legend('Total mass')
n = n+1;
figure(n)
subplot(2,1,1)
plot(t,(X(:,1:6)))
title('weight fraction, first stage')
xlabel('time, hr')
ylabel('wt%')
legend('MEA','H20','HEF','NaOH','NaF','HEPO')
subplot(2,1,2)
plot(t,(X(:,22:27)))
title('weight fraction, second stage')
xlabel('time, hr')
ylabel('wt%')
legend('MEA','H20','HEF','NaOH','NaF','HEPO')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,11:13).*[X(:,14).*1000 X(:,14).*1000 X(:,14).*1000];
plot(t,x11)
xlabel('time, hr')
ylabel('kg/hr vapour')
legend('MEA','H2O','CO2')
title('first stage vapour flow')
subplot(2,1,2)
xvap2 = X(:,31:33).*[X(:,34).*650 X(:,34).*650 X(:,34).*650];
plot(t,xvap2)
%hold on
%plot(t,(X(:,32).*X(34).*650))
%hold off
xlabel('time, hr')
ylabel('kg/hr vapour')
legend('MEA','H2O','CO2')
title('second stage vapour flow')
n = n+1;
figure(n)
subplot(2,1,1)
x11 = X(:,15:20).*[X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500 X(:,21).*1500];
plot(t, x11)
legend('MEA','H20','HEF','NaOH','NaF','HEPO')
xlabel('time, hr')
ylabel('Components in outlet stream [kg/hr]')
title('First stage liquid flow')
subplot(2,1,2)
x11 = X(:,35:40).*[X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000 X(:,41).*1000];
plot(t, x11)
legend('MEA','H20','HEF','NaOH','NaF','HEPO')
xlabel('time, hr')
ylabel('Components in outlet stream [kg/hr]')
title('Second stage liquid flow')
n = n+1;
figure(n)
x11 = [X(:,42:43) X(:,45)].*10e6;
plot(t,x11)
legend('Q1','Q2','Qlost')
xlabel('time,hr')
ylabel('kJ')
title('Energy consumption in the different stages, and energy lost with waste')